import axios from 'axios';
import store from '../store';
import { ADD, GET, GET_ALL, UPDATE, DELETE, INSPECT } from './TaskType';
const base_url='/api/task';

export const getTasks= (error=(reason)=>{console.error(reason)}) => dispatch => {
	axios
		.get(base_url)
		.then(
			(value)=>
			dispatch({
				type: GET_ALL,
				payload: value.data
			})
			,(reason)=>{
				if(error&&typeof(error)==="function") error(reason)
			}
		);
}
export const getTask= (id,error=(reason)=>{console.error(reason)}) => dispatch => {
	axios
		.get(base_url+`/${id}`)
		.then(
			(value)=>
			dispatch({
				type: GET,
				payload: value.data
			})
			,(reason)=>{
				if(error&&typeof(error)==="function") error(reason)
			}
		);
}
export const addTask= (task,error=(reason)=>{console.error(reason)}) => dispatch => {
	axios
		.post(base_url, task)
		.then(
			(value)=>	
				dispatch({
					type: ADD,
					payload: value.data
				})
			,(reason)=>{
				if(error&&typeof(error)==="function") error(reason)
			}
	);
}
export const deleteTask= (id,error=(reason)=>{console.error(reason)}) => dispatch => {
	axios
		.delete(base_url+`/${id}`)
		.then(
			(value)=>
			dispatch({
				type: DELETE,
				payload: id
			})
			,(reason)=>{
				if(error&&typeof(error)==="function") error(reason)
			}
	);
}
export const updateTask= (task,error=(reason)=>{console.error(reason)}) => dispatch => {
	axios
		.put(base_url+`/${task._id}`, task)
		.then(
			(value)=>
			dispatch({
				type: UPDATE,
				payload: task
			})
			,(reason)=>{
				if(error&&typeof(error)==="function") error(reason)
			}
	);
}
export const inspectTask= (id) => {
	return store.dispatch ({
		type: INSPECT,
		payload: id
	});
}