import React from "react";
import PropTypes from "prop-types";
import { connect } from "react-redux";
import { inspectTask } from "../../action/TaskAction";
import "../../style/task/Task.scss";

function Task(props) {
	return (
		<div id={props.task._id} className="task">
			<button className="edit icon-pencil-circled" type="button" onClick={()=>{inspectTask(props.task._id);}} title="Edit"></button>
			<div className="id">{props.task._id}</div>
			<div className="name">{props.task.name}</div>
			<div className="description">{props.task.description}</div>
		</div>
	);
}
Task.propTypes = {
	inspectTask: PropTypes.func.isRequired,
	task: PropTypes.object.isRequired
};

export default connect(null,{inspectTask})(Task);